%global basepkg postfix
%global epoch %(rpm -qp --queryformat '%{EPOCH}' %{_sourcedir}/%{basepkg}-*-*%{dist}.%{_arch}.rpm)
%global version %(rpm -qp --queryformat '%{VERSION}' %{_sourcedir}/%{basepkg}-*-*%{dist}.%{_arch}.rpm)
%global baserelease %(rpm -qp --queryformat '%{RELEASE}' %{_sourcedir}/%{basepkg}-*-*%{dist}.%{_arch}.rpm)
%global chlog %(date "+%a %b %d %Y")

# Globals from base package
%global alt_suffix .%{basepkg}
%global postfix_user %{basepkg}
%global maildrop_group postdrop

Summary: Configuration files for a second instance of Postfix MTA
Name: %{basepkg}-instance2
Epoch: %{epoch}
Version: %{version}
Release: 3.%{baserelease}
License: GPL-2.0-only
Group: System Environment/Daemons
Packager: Simon Matter <simon.matter@invoca.ch>
Vendor: Invoca Systems
Distribution: Invoca Linux Server
Source0: %{basepkg}-%{version}-%{baserelease}.%{_arch}.rpm
Source1: postfix-instance2_wrapper.sh
Source2: postfix-instance2-README.RPM
Patch0: postfix-2.5.2-multi_instance.patch
Patch1: postfix-2.7.0-RC1-main2.patch
BuildRequires: rpm, sed, systemd-units
# This can not be a noarch package because config files can differ on different archs
Requires: %{basepkg}%{_isa} = %{epoch}:%{version}-%{baserelease}
%systemd_requires
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
This package provides the configuration files to run a second, alternative
instance of the Postfix Mail Transport Agent.

%prep
%setup -c -T
rpm2cpio %{SOURCE0} | %{__cpio} -idm
%{__install} -m 0644 -p %{SOURCE2} README.RPM

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%{__install} -d %{buildroot}%{_sysconfdir}/%{basepkg}
%{__install} -d %{buildroot}%{_sysconfdir}/%{basepkg}2
%{__install} -d %{buildroot}%{_bindir}
%{__install} -d %{buildroot}%{_sbindir}
%{__install} -d %{buildroot}%{_unitdir}
%{__install} -d %{buildroot}%{_libexecdir}/%{basepkg}
%{__install} -d %{buildroot}%{_var}/lib
%{__install} -d %{buildroot}%{_var}/spool

%{__cp} -a %{_builddir}/%{name}-%{version}%{_var}/lib/%{basepkg} %{buildroot}%{_var}/lib/%{basepkg}2
%{__cp} -a %{_builddir}/%{name}-%{version}%{_var}/spool/%{basepkg} %{buildroot}%{_var}/spool/%{basepkg}2

%{__cp} -a %{_builddir}/%{name}-%{version}%{_sysconfdir}/%{basepkg}/main.cf %{buildroot}%{_sysconfdir}/%{basepkg}/main.cf.instance2
%{__patch} --no-backup-if-mismatch %{buildroot}%{_sysconfdir}/%{basepkg}/main.cf.instance2 < %{PATCH0}
touch -r %{_builddir}/%{name}-%{version}%{_sysconfdir}/%{basepkg}/main.cf %{buildroot}%{_sysconfdir}/%{basepkg}/main.cf.instance2

%{__sed} \
  -e "s|^smtp      inet|8025      inet|g" \
  -e "s|=%{basepkg}\/|=%{basepkg}2/|g" \
  %{_builddir}/%{name}-%{version}%{_sysconfdir}/%{basepkg}/master.cf > %{buildroot}%{_sysconfdir}/%{basepkg}2/master.cf
touch -r %{_builddir}/%{name}-%{version}%{_sysconfdir}/%{basepkg}/master.cf %{buildroot}%{_sysconfdir}/%{basepkg}2/master.cf

%{__cp} -a %{buildroot}%{_sysconfdir}/%{basepkg}/main.cf.instance2 %{buildroot}%{_sysconfdir}/%{basepkg}2/main.cf
%{__patch} --no-backup-if-mismatch %{buildroot}%{_sysconfdir}/%{basepkg}2/main.cf < %{PATCH1}
touch -r %{_builddir}/%{name}-%{version}%{_sysconfdir}/%{basepkg}/main.cf %{buildroot}%{_sysconfdir}/%{basepkg}2/main.cf

%{__sed} \
  -e "s|=Postfix Mail Transport Agent|=Postfix Mail Transport Agent (alternative second instance)|g" \
  -e "s|=forking|=forking\nEnvironment=MAIL_CONFIG=/etc/%{basepkg}2|g" \
  -e "s|\/spool\/%{basepkg}\/|/spool/%{basepkg}2/|g" \
  %{_builddir}/%{name}-%{version}%{_unitdir}/%{basepkg}.service > %{buildroot}%{_unitdir}/%{basepkg}2.service
touch -r %{_builddir}/%{name}-%{version}%{_unitdir}/%{basepkg}.service %{buildroot}%{_unitdir}/%{basepkg}2.service

%{__install} -m 0755 -p %{SOURCE1} %{buildroot}%{_libexecdir}/%{basepkg}/instance2_wrapper
for F in $(%{__grep} -lse "MAIL_CONFIG" %{_builddir}/%{name}-%{version}%{_prefix}/*bin/* |
  %{__sed} -e "s|^%{_builddir}/%{name}-%{version}||g" -e "s|\%{alt_suffix}$||g" |
  %{__grep} -vse "\/postmulti$"); do
    %{__ln_s} %{_libexecdir}/%{basepkg}/instance2_wrapper %{buildroot}${F}2
done

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%post
%systemd_post %{basepkg}2.service

%preun
%systemd_preun %{basepkg}2.service

%postun
%systemd_postun_with_restart %{basepkg}2.service

%files
%defattr(-,root,root,-)
%doc README.RPM
%{_sysconfdir}/%{basepkg}/main.cf.instance2
%dir %{_sysconfdir}/%{basepkg}2
%config(noreplace) %{_sysconfdir}/%{basepkg}2/main.cf
%config(noreplace) %{_sysconfdir}/%{basepkg}2/master.cf
%dir %attr(0700,%{postfix_user},root) %{_var}/lib/%{basepkg}2
%dir %{_var}/spool/%{basepkg}2
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/active
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/bounce
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/corrupt
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/defer
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/deferred
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/flush
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/hold
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/incoming
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/private
%dir %attr(0730,%{postfix_user},%{maildrop_group})      %{_var}/spool/%{basepkg}2/maildrop
%dir %attr(0710,%{postfix_user},%{maildrop_group})      %{_var}/spool/%{basepkg}2/public
%dir                                                    %{_var}/spool/%{basepkg}2/pid
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/saved
%dir %attr(0700,%{postfix_user},root)                   %{_var}/spool/%{basepkg}2/trace
%{_unitdir}/%{basepkg}2.service
%{_libexecdir}/%{basepkg}/instance2_wrapper
%{_bindir}/*2
%{_sbindir}/*2

%changelog
* %{chlog} Simon Matter <simon.matter@invoca.ch> %{version}-%{release}
- remove eval where possible
- change to SPDX license tag

* Tue Dec 27 2022 Simon Matter <simon.matter@invoca.ch> %%version-2.%%release
- major improvements

* Sat Dec 24 2022 Simon Matter <simon.matter@invoca.ch> %%version-1.%%release
- initial package
